#include <stdio.h>
#include <errno.h>

#include "vars.h"
#define PAT_MAX 9

void get_opt(char* CONFIG)
{
 FILE *conf;
 char tmp[MAX],pairs,*rez;
 const char *errstr; 
 pcre* pat[PAT_MAX];
 pcre_extra *spat[PAT_MAX];
 unsigned int h_flag=0,i,j,vector[MAX],vecsize=MAX, errchar,z;
 char pattern[PAT_MAX][100];

  /********** Set pattern ************************/
  sprintf(pattern[0],"^\\s*#");
  sprintf(pattern[1],"^\\s*error_log\\s+(\\S+)");
  sprintf(pattern[2],"^\\s*change_log\\s+(\\S+)");
  sprintf(pattern[3],"^\\s*\\<(\\S+)\\>");
  sprintf(pattern[4],"^\\s*ban_file\\s+(\\S+)");
  sprintf(pattern[5],"^\\s*url\\s+(\\S+)");
  sprintf(pattern[6],"^\\s*pre_pattern\\s+(\\S+)");
  sprintf(pattern[7],"^\\s*post_pattern\\s+(\\S+)");
  sprintf(pattern[8],"^\\s*allow_ip\\s+(\\S+)");
  /********* Init vars ***************/
  err_log[0]=0;
  chg_log[0]=0;
  redir_count=0;
  for(i=0;i<MAX_REDIR;i++)
  {
   redir[i].name[0]=0;  
   redir[i].ban_file[0]=0;
   redir[i].url[0]=0;  
   redir[i].pre_pat[0]=0;  
   redir[i].post_pat[0]=0;  
   redir[i].count=0;  
   redir[i].ip_count=0;  
  }
/*********** Load pattern ************/
   for(i=0;i<PAT_MAX;i++)
   {
    /********* Compile pattern **************/
     if((pat[i]=pcre_compile(pattern[i],PCRE_CASELESS,&errstr,&errchar,NULL))==NULL)
        {
         sprintf(tmp,"ERROR: Can't compile pattern: i=%i %s",i,errstr);
         printf("%s\n",tmp);
        exit(-1);
        }

    /******* Optimize pattern ***************/
     spat[i]=pcre_study(pat[i],0,&errstr);    
   }
/******** OPEN redirector.conf *****************/
if ((conf=fopen(CONFIG,"r"))==NULL)
       {
        sprintf(tmp,"ERROR: Can't open config file %s: %s\n",CONFIG,strerror(errno));
	printf("%s",tmp);
        exit(-1);
       }
/************** Load vars from config *************/
while (!feof(conf))
{
 fgets(tmp,MAX,conf);
    
  // Comment "#"  
    if((pairs=pcre_exec(pat[0],spat[0],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
      continue;

  // error log  
    if((pairs=pcre_exec(pat[1],spat[1],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      strcpy(err_log,rez);
      continue;
     }
   // change log  
    if((pairs=pcre_exec(pat[2],spat[2],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      strcpy(chg_log,rez);
      continue;
     }

   // First <HEADER>  
    if(!h_flag && (pairs=pcre_exec(pat[3],spat[3],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      strcpy(redir[redir_count].name,rez);
      h_flag=1;
      continue;
     }

   // Next <HEADER>  
    if(h_flag && (pairs=pcre_exec(pat[3],spat[3],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      redir_count++;
      strcpy(redir[redir_count].name,rez);
      continue;
     }

   // ban_file  
    if(h_flag && (pairs=pcre_exec(pat[4],spat[4],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      strcpy(redir[redir_count].ban_file,rez);
      continue;
     }

   // url  
    if(h_flag && (pairs=pcre_exec(pat[5],spat[5],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      strcpy(redir[redir_count].url,rez);
      continue;
     }

   // pre_pattern
    if(h_flag && (pairs=pcre_exec(pat[6],spat[6],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      strcpy(redir[redir_count].pre_pat,rez);
      continue;
     }

   // post_pattern
    if(h_flag && (pairs=pcre_exec(pat[7],spat[7],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      strcpy(redir[redir_count].post_pat,rez);
      continue;
     }

   // ip_allow
    if(h_flag && (pairs=pcre_exec(pat[8],spat[8],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      strcpy(redir[redir_count].allow_ip[redir[redir_count].ip_count],rez);
      redir[redir_count].ip_count++;
      if (redir[redir_count].ip_count>MAX_ALLOW_IP) 
         {
	  printf("ERROR: count of allow_ip >MAX_ALLOW_IP\n  Edit vars.h for repair\n");
	  exit(-1);
	 }
      continue;
     }


//printf("%s",tmp);
 }

    if (redir_count >=MAX_REDIR) 
     {
      printf("ERROR: Count of <header> in config file > max count for header defined.\n Edit MAX_REDIR in vars.h for repair\n");
      exit(-1);
     }

fclose(conf);    
redir_count+=h_flag;

/********** Check for error in config file *******/
for (z=0;z<redir_count; z++)
{
 if (!redir[z].name[0])
      { printf("Error interpretation <HEADER> in config file\n"); exit(-1);}
 if (!redir[z].ban_file[0])
      { printf("Error in config file: not found ban_file option for %s\n",redir[z].name); exit(-1);}
 if (!redir[z].url[0])
      { printf("Error in config file: not found url option for %s\n",redir[z].name); exit(-1);}

}

/*
printf("\n==============================\n");
if (err_log[0])  printf(" error log:%s\n",err_log);
else printf(" error log: none\n");

if (chg_log[0])  printf("change log:%s\n",chg_log);
else printf("change log: none\n");

printf("Redir counter: %i\n",redir_count);

    for (z=0;z<redir_count; z++)
    {
     printf ("============================\n");
     printf ("Name: %s\n",redir[z].name);
     printf ("      File: %s\n",redir[z].ban_file);
     printf ("       URL: %s\n",redir[z].url);

     if (redir[z].pre_pat[0])  printf("     pre_p: %s\n",redir[z].pre_pat);
     else printf("     pre_p: none\n");

     if (redir[z].post_pat[0])  printf("    post_p: %s\n",redir[z].post_pat);
     else printf("    post_p: none\n");

     printf("       PAT: %s%%s%s\n",redir[z].pre_pat,redir[z].post_pat);
 
    printf("  ip_count: %i\n",redir[z].ip_count);
     for(j=0;j<redir[z].ip_count;j++)
     {
       printf("  allow-ip: {%s}\n",redir[z].allow_ip[j]);
     }

    }
*/
}
