#include <stdio.h>
#include <errno.h>
#include <pcre.h>
#include "vars.h"

void load_ban_list(void)
{
    FILE *fp;
    int i;
    char str[MAX],tmp[MAX];
    const char *errstr; 
    unsigned int errchar; 

    
for (i=0;i<redir_count;i++)
{
/******** OPEN porno.ban *****************/
if ((fp=fopen(redir[i].ban_file,"r"))==NULL)
       {
        sprintf(tmp,"ERROR: Can't open file %s: %s",redir[i].ban_file,strerror(errno));
        err_mes(tmp);exit(-1);
       }
	
/***** LOAD porno.ban *******/
   while(!feof(fp))
   {
    if (redir[i].count>=MAX) 
       {
        printf("ERROR: Line count in %s > MAX.\n Edit MAX in vars.h for repair\n",redir[i].ban_file);
	exit(-1);
       }
    fgets(str,MAX,fp);
    sprintf(tmp,"%s%s%s",redir[i].pre_pat,str,redir[i].post_pat);
//    sprintf(tmp,"^%s",str);

    // chomp
    if (tmp[strlen(tmp)-1]==0x0a) 
       {tmp[strlen(tmp)-1]=0;}
//    printf("%i\t%i %s\n",i,redir[i].count,tmp);

    /******* Compile pattern *****************/    
    if((redir[i].pat[redir[i].count]=pcre_compile(tmp,PCRE_CASELESS,&errstr,&errchar,NULL))==NULL)
       {
        sprintf(tmp,"ERROR: Can't compile pattern in %s line:%i %s",redir[i].ban_file,redir[i].count+1,errstr);
        err_mes(tmp);exit(-1);
       }

   /******* Optimize pattern ***************/
    redir[i].spat[redir[i].count]=pcre_study(redir[i].pat[redir[i].count],0,&errstr);    
    
    redir[i].count++;
    }
    
    fclose(fp);

    sprintf(tmp,"Load %i pattern from %s",redir[i].count,redir[i].ban_file);
    err_mes(tmp);
} // for i
} 
