#include <stdio.h>
#include <errno.h>
#include <time.h>
#include <pcre.h>
#include "vars.h"

int main(int argc, char* argv[])
{
    char str[MAX],tmp[MAX],
	 pairs, *url,*who,*ident,*method;

    pcre *input; 
    pcre_extra *input_s;
    const char *errstr; 
    unsigned int errchar; 
    unsigned int vector[MAX];
    unsigned int vecsize=MAX;
    unsigned int flag,i,z,j;
    char input_pat[]="^(\\S+) ([\\d\\.]+)\\/\\S* (\\S+) (\\S+)$"; 
    FILE *log;


if (argc!=2) {get_opt("/usr/local/ban/redirector.conf");}
else {get_opt(argv[1]);}
load_ban_list();

/****************** Input pattern ********************/
    if((input=pcre_compile(input_pat,PCRE_CASELESS,&errstr,&errchar,NULL))==NULL)
    {
     sprintf(str,"Compile error in input: %s\nSymbol# %i\nPattern:%s\n",errstr,errchar,input_pat);
     perror(str);
     exit(-1);
    }
    input_s=pcre_study(input,0,&errstr);    

/******** OPEN LOG FILE *****************/
if (chg_log[0])
if ((log=fopen(chg_log,"a"))==NULL)
       {
        sprintf(tmp,"ERROR: Can't make log file %s: %s\n",chg_log,strerror(errno));
        printf(tmp);exit(-1);
        }

err_mes("Redirector start and working");
/************* main cycle *********************/
while (fgets(str,65535,stdin)!=NULL)
{
 /************* Get input data ****************/
    if((pairs=pcre_exec(input,input_s,str,strlen(str),0,PCRE_NOTEMPTY,vector,vecsize))<0)
    { // if unknow format 
     printf("%s",str);
     continue;
    }
    else 
    { // split data
    url=str+vector[2];    
    str[vector[3]]=0;

    who=str+vector[4];    
    str[vector[5]]=0;

    ident=str+vector[6];    
    str[vector[7]]=0;

    method=str+vector[8];    
    str[vector[9]]=0;
    }
 /**********************************************
  *************** Check Rulez ******************/
flag=0;

for (z=0;z<redir_count;z++)
{


// Check for pattern from BAN files
  for (i=0;i<redir[z].count;i++)
 {
    if((pairs=pcre_exec(redir[z].pat[i],redir[z].spat[i],url,strlen(url),0,PCRE_NOTEMPTY,vector,vecsize))>=0)
    {

    // Check for allow IP
      for(j=0;j<redir[z].ip_count;j++)
      {
       if(strncmp(who,redir[z].allow_ip[j],strlen(redir[z].allow_ip[j]))==0) 
        {
         printf("%s %s %s %s\n",url,who,ident,method);
         fflush(stdout);
         flag=1;
         break;
        }
      }
     if (flag) break;

     printf("%s %s %s %s\n",redir[z].url,who,ident,method);
     fflush(stdout);
     if(chg_log[0])
     {
      fprintf(log,"%s %s %s %s -> %s (%s line %i)\n",now(),redir[z].name,who,url,redir[z].url,redir[z].ban_file,i+1);
      fflush (log);
     }
     flag=1;
     break;
    }
  }
  if (flag) break;
} //for z
if (!flag) {
           printf("%s %s %s %s\n",url,who,ident,method);
           fflush(stdout);
	  }
}// while main cycle
}//main